> ## Documentation Index
> Fetch the complete documentation index at: https://novu-c5de82d9-docs-homepage-redesign.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a channel endpoint

> Create a channel endpoint using the Novu REST API. Requires your environment secret key in the Authorization header.



## OpenAPI

````yaml POST /v1/channel-endpoints
openapi: 3.0.0
info:
  title: Novu API
  description: >-
    Novu REST API. Please see https://docs.novu.co/api-reference for more
    details.
  version: 3.15.0
  contact:
    name: Novu Support
    url: https://discord.gg/novu
    email: support@novu.co
  termsOfService: https://novu.co/terms
  license:
    name: MIT
    url: https://opensource.org/license/mit
servers:
  - url: https://api.novu.co
  - url: https://eu.api.novu.co
security:
  - secretKey: []
tags:
  - name: Events
    description: >-
      Events represent a change in state of a subscriber. They are used to
      trigger workflows, and enable you to send notifications to subscribers
      based on their actions.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Subscribers
    description: >-
      A subscriber in Novu represents someone who should receive a message. A
      subscriber's profile information contains important attributes about the
      subscriber that will be used in messages (name, email). The subscriber
      object can contain other key-value pairs that can be used to further
      personalize your messages.
    externalDocs:
      url: https://docs.novu.co/subscribers/subscribers
  - name: Topics
    description: >-
      Topics are a way to group subscribers together so that they can be
      notified of events at once. A topic is identified by a custom key. This
      can be helpful for things like sending out marketing emails or notifying
      users of new features. Topics can also be used to send notifications to
      the subscribers who have been grouped together based on their interests,
      location, activities and much more.
    externalDocs:
      url: https://docs.novu.co/subscribers/topics
  - name: Integrations
    description: >-
      With the help of the Integration Store, you can easily integrate your
      favorite delivery provider. During the runtime of the API, the
      Integrations Store is responsible for storing the configurations of all
      the providers.
    externalDocs:
      url: https://docs.novu.co/platform/integrations/overview
  - name: Workflows
    description: >-
      All notifications are sent via a workflow. Each workflow acts as a
      container for the logic and blueprint that are associated with a type of
      notification in your system.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Messages
    description: >-
      A message in Novu represents a notification delivered to a recipient on a
      particular channel. Messages contain information about the request that
      triggered its delivery, a view of the data sent to the recipient, and a
      timeline of its lifecycle events. Learn more about messages.
    externalDocs:
      url: https://docs.novu.co/workflows/messages
  - name: Environments
    description: >-
      Environments allow you to manage different stages of your application
      development lifecycle. Each environment has its own set of API keys and
      configurations, enabling you to separate development, staging, and
      production workflows.
    externalDocs:
      url: https://docs.novu.co/platform/environments
  - name: Layouts
    description: Layouts are reusable wrappers for your email notifications.
    externalDocs:
      url: https://docs.novu.co/platform/workflow/layouts
  - name: Translations
    description: Used to localize your notifications to different languages.
    externalDocs:
      url: https://docs.novu.co/platform/workflow/advanced-features/translations
  - name: Domains
    description: Used to manage your inbound email domains.
    externalDocs:
      url: https://docs.novu.co/platform/domains
externalDocs:
  description: Novu Documentation
  url: https://docs.novu.co
paths:
  /v1/channel-endpoints:
    post:
      tags:
        - Channel Endpoints
      summary: Create a channel endpoint
      description: Create a new channel endpoint for a resource.
      operationId: ChannelEndpointsController_createChannelEndpoint
      parameters:
        - name: idempotency-key
          in: header
          description: A header for idempotency purposes
          required: false
          schema:
            type: string
      requestBody:
        required: true
        description: >-
          Channel endpoint creation request. The structure varies based on the
          type field.
        content:
          application/json:
            schema:
              oneOf:
                - $ref: '#/components/schemas/CreateSlackChannelEndpointDto'
                - $ref: '#/components/schemas/CreateSlackUserEndpointDto'
                - $ref: '#/components/schemas/CreateWebhookEndpointDto'
                - $ref: '#/components/schemas/CreatePhoneEndpointDto'
                - $ref: '#/components/schemas/CreateMsTeamsChannelEndpointDto'
                - $ref: '#/components/schemas/CreateMsTeamsUserEndpointDto'
                - $ref: '#/components/schemas/CreateTelegramChatEndpointDto'
              discriminator:
                propertyName: type
                mapping:
                  slack_channel:
                    $ref: '#/components/schemas/CreateSlackChannelEndpointDto'
                  slack_user:
                    $ref: '#/components/schemas/CreateSlackUserEndpointDto'
                  webhook:
                    $ref: '#/components/schemas/CreateWebhookEndpointDto'
                  phone:
                    $ref: '#/components/schemas/CreatePhoneEndpointDto'
                  ms_teams_channel:
                    $ref: '#/components/schemas/CreateMsTeamsChannelEndpointDto'
                  ms_teams_user:
                    $ref: '#/components/schemas/CreateMsTeamsUserEndpointDto'
                  telegram_chat:
                    $ref: '#/components/schemas/CreateTelegramChatEndpointDto'
      responses:
        '201':
          description: Created
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetChannelEndpointResponseDto'
        '400':
          description: Bad Request
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '401':
          description: Unauthorized
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '403':
          description: Forbidden
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '404':
          description: Not Found
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '405':
          description: Method Not Allowed
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '409':
          description: Conflict
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '413':
          description: Payload Too Large
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '414':
          description: URI Too Long
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '415':
          description: Unsupported Media Type
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '422':
          description: Unprocessable Entity
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidationErrorDto'
        '429':
          description: 'The client has sent too many requests in a given amount of time. '
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
            Retry-After:
              $ref: '#/components/headers/Retry-After'
          content:
            application/json:
              schema:
                type: string
                example: API rate limit exceeded
        '500':
          description: Internal Server Error
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '503':
          description: >-
            The server is currently unable to handle the request due to a
            temporary overload or scheduled maintenance, which will likely be
            alleviated after some delay.
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
            Retry-After:
              $ref: '#/components/headers/Retry-After'
          content:
            application/json:
              schema:
                type: string
                example: Please wait some time, then try again.
      security:
        - secretKey: []
        - secretKey: []
      x-codeSamples:
        - lang: php
          label: PHP
          source: |-
            declare(strict_types=1);

            require 'vendor/autoload.php';

            use novu;
            use novu\Models\Components;

            $sdk = novu\Novu::builder()
                ->setSecurity(
                    'YOUR_SECRET_KEY_HERE'
                )
                ->build();



            $response = $sdk->channelEndpoints->create(
                requestBody: new Components\CreateSlackChannelEndpointDto(
                    subscriberId: 'subscriber-123',
                    integrationIdentifier: 'slack-prod',
                    type: Components\CreateSlackChannelEndpointDtoType::SlackChannel,
                    endpoint: new Components\SlackChannelEndpointDto(
                        channelId: 'C123456789',
                    ),
                )
            );

            if ($response->getChannelEndpointResponseDto !== null) {
                // handle response
            }
        - lang: python
          label: Python
          source: |-
            import novu_py
            from novu_py import Novu


            with Novu(
                secret_key="YOUR_SECRET_KEY_HERE",
            ) as novu:

                res = novu.channel_endpoints.create(request_body={
                    "subscriber_id": "subscriber-123",
                    "integration_identifier": "slack-prod",
                    "type": novu_py.CreateSlackChannelEndpointDtoType.SLACK_CHANNEL,
                    "endpoint": {
                        "channel_id": "C123456789",
                    },
                })

                # Handle response
                print(res)
        - lang: go
          label: Go
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/novuhq/novu-go/v3\"\n\t\"github.com/novuhq/novu-go/v3/models/components\"\n\t\"github.com/novuhq/novu-go/v3/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := v3.New(\n        v3.WithSecurity(\"YOUR_SECRET_KEY_HERE\"),\n    )\n\n    res, err := s.ChannelEndpoints.Create(ctx, operations.CreateChannelEndpointsControllerCreateChannelEndpointRequestBodySlackChannel(\n        components.CreateSlackChannelEndpointDto{\n            SubscriberID: \"subscriber-123\",\n            IntegrationIdentifier: \"slack-prod\",\n            Type: components.CreateSlackChannelEndpointDtoTypeSlackChannel,\n            Endpoint: components.SlackChannelEndpointDto{\n                ChannelID: \"C123456789\",\n            },\n        },\n    ), nil)\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.GetChannelEndpointResponseDto != nil {\n        switch res.GetChannelEndpointResponseDto.Endpoint.Type {\n            case components.EndpointTypeSlackChannelEndpointDto:\n                // res.GetChannelEndpointResponseDto.Endpoint.SlackChannelEndpointDto is populated\n            case components.EndpointTypeSlackUserEndpointDto:\n                // res.GetChannelEndpointResponseDto.Endpoint.SlackUserEndpointDto is populated\n            case components.EndpointTypeWebhookEndpointDto:\n                // res.GetChannelEndpointResponseDto.Endpoint.WebhookEndpointDto is populated\n            case components.EndpointTypePhoneEndpointDto:\n                // res.GetChannelEndpointResponseDto.Endpoint.PhoneEndpointDto is populated\n            case components.EndpointTypeMsTeamsChannelEndpointDto:\n                // res.GetChannelEndpointResponseDto.Endpoint.MsTeamsChannelEndpointDto is populated\n            case components.EndpointTypeMsTeamsUserEndpointDto:\n                // res.GetChannelEndpointResponseDto.Endpoint.MsTeamsUserEndpointDto is populated\n            case components.EndpointTypeTelegramChatEndpointDto:\n                // res.GetChannelEndpointResponseDto.Endpoint.TelegramChatEndpointDto is populated\n        }\n\n    }\n}"
        - lang: typescript
          label: TypeScript
          source: |-
            import { Novu } from "@novu/api";

            const novu = new Novu({
              secretKey: "YOUR_SECRET_KEY_HERE",
            });

            async function run() {
              const result = await novu.channelEndpoints.create({
                subscriberId: "subscriber-123",
                integrationIdentifier: "slack-prod",
                type: "slack_channel",
                endpoint: {
                  channelId: "C123456789",
                },
              });

              console.log(result);
            }

            run();
        - lang: csharp
          label: Csharp (SDK)
          source: >-
            using Novu;

            using Novu.Models.Components;

            using Novu.Models.Requests;


            var sdk = new NovuSDK(secretKey: "YOUR_SECRET_KEY_HERE");


            var res = await sdk.ChannelEndpoints.CreateAsync(requestBody:
            ChannelEndpointsControllerCreateChannelEndpointRequestBody.CreateSlackChannel(
                new CreateSlackChannelEndpointDto() {
                    SubscriberId = "subscriber-123",
                    IntegrationIdentifier = "slack-prod",
                    Type = CreateSlackChannelEndpointDtoType.SlackChannel,
                    Endpoint = new SlackChannelEndpointDto() {
                        ChannelId = "C123456789",
                    },
                }
            ));


            // handle response
components:
  schemas:
    CreateSlackChannelEndpointDto:
      type: object
      properties:
        identifier:
          type: string
          description: >-
            The unique identifier for the channel endpoint. If not provided, one
            will be generated automatically.
          example: slack-channel-user123-abc4
        subscriberId:
          type: string
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        integrationIdentifier:
          type: string
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          description: >-
            The identifier of the channel connection to use for this channel
            endpoint.
          example: slack-connection-abc123
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - slack_channel
          example: slack_channel
        endpoint:
          description: Slack channel endpoint data
          allOf:
            - $ref: '#/components/schemas/SlackChannelEndpointDto'
      required:
        - subscriberId
        - integrationIdentifier
        - type
        - endpoint
    CreateSlackUserEndpointDto:
      type: object
      properties:
        identifier:
          type: string
          description: >-
            The unique identifier for the channel endpoint. If not provided, one
            will be generated automatically.
          example: slack-channel-user123-abc4
        subscriberId:
          type: string
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        integrationIdentifier:
          type: string
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          description: >-
            The identifier of the channel connection to use for this channel
            endpoint.
          example: slack-connection-abc123
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - slack_user
          example: slack_user
        endpoint:
          description: Slack user endpoint data
          allOf:
            - $ref: '#/components/schemas/SlackUserEndpointDto'
      required:
        - subscriberId
        - integrationIdentifier
        - type
        - endpoint
    CreateWebhookEndpointDto:
      type: object
      properties:
        identifier:
          type: string
          description: >-
            The unique identifier for the channel endpoint. If not provided, one
            will be generated automatically.
          example: slack-channel-user123-abc4
        subscriberId:
          type: string
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        integrationIdentifier:
          type: string
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          description: >-
            The identifier of the channel connection to use for this channel
            endpoint.
          example: slack-connection-abc123
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - webhook
          example: webhook
        endpoint:
          description: Webhook endpoint data
          allOf:
            - $ref: '#/components/schemas/WebhookEndpointDto'
      required:
        - subscriberId
        - integrationIdentifier
        - type
        - endpoint
    CreatePhoneEndpointDto:
      type: object
      properties:
        identifier:
          type: string
          description: >-
            The unique identifier for the channel endpoint. If not provided, one
            will be generated automatically.
          example: slack-channel-user123-abc4
        subscriberId:
          type: string
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        integrationIdentifier:
          type: string
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          description: >-
            The identifier of the channel connection to use for this channel
            endpoint.
          example: slack-connection-abc123
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - phone
          example: phone
        endpoint:
          description: Phone endpoint data
          allOf:
            - $ref: '#/components/schemas/PhoneEndpointDto'
      required:
        - subscriberId
        - integrationIdentifier
        - type
        - endpoint
    CreateMsTeamsChannelEndpointDto:
      type: object
      properties:
        identifier:
          type: string
          description: >-
            The unique identifier for the channel endpoint. If not provided, one
            will be generated automatically.
          example: slack-channel-user123-abc4
        subscriberId:
          type: string
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        integrationIdentifier:
          type: string
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          description: >-
            The identifier of the channel connection to use for this channel
            endpoint.
          example: slack-connection-abc123
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - ms_teams_channel
          example: ms_teams_channel
        endpoint:
          description: MS Teams channel endpoint data
          allOf:
            - $ref: '#/components/schemas/MsTeamsChannelEndpointDto'
      required:
        - subscriberId
        - integrationIdentifier
        - type
        - endpoint
    CreateMsTeamsUserEndpointDto:
      type: object
      properties:
        identifier:
          type: string
          description: >-
            The unique identifier for the channel endpoint. If not provided, one
            will be generated automatically.
          example: slack-channel-user123-abc4
        subscriberId:
          type: string
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        integrationIdentifier:
          type: string
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          description: >-
            The identifier of the channel connection to use for this channel
            endpoint.
          example: slack-connection-abc123
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - ms_teams_user
          example: ms_teams_user
        endpoint:
          description: MS Teams user endpoint data
          allOf:
            - $ref: '#/components/schemas/MsTeamsUserEndpointDto'
      required:
        - subscriberId
        - integrationIdentifier
        - type
        - endpoint
    CreateTelegramChatEndpointDto:
      type: object
      properties:
        identifier:
          type: string
          description: >-
            The unique identifier for the channel endpoint. If not provided, one
            will be generated automatically.
          example: slack-channel-user123-abc4
        subscriberId:
          type: string
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        integrationIdentifier:
          type: string
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          description: >-
            The identifier of the channel connection to use for this channel
            endpoint.
          example: slack-connection-abc123
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - telegram_chat
          example: telegram_chat
        endpoint:
          description: Telegram chat endpoint data
          allOf:
            - $ref: '#/components/schemas/TelegramChatEndpointDto'
      required:
        - subscriberId
        - integrationIdentifier
        - type
        - endpoint
    GetChannelEndpointResponseDto:
      type: object
      properties:
        identifier:
          type: string
          description: The unique identifier of the channel endpoint.
        channel:
          nullable: true
          enum:
            - in_app
            - email
            - sms
            - chat
            - push
          type: string
          description: The channel type (email, sms, push, chat, etc.).
        providerId:
          type: string
          nullable: true
          description: The provider identifier (e.g., sendgrid, twilio, slack, etc.).
          enum:
            - emailjs
            - mailgun
            - mailjet
            - mandrill
            - nodemailer
            - postmark
            - sendgrid
            - sendinblue
            - ses
            - netcore
            - infobip-email
            - resend
            - plunk
            - mailersend
            - mailtrap
            - clickatell
            - outlook365
            - novu-email
            - sparkpost
            - email-webhook
            - braze
            - novu-email-agent
            - nexmo
            - plivo
            - sms77
            - sms-central
            - sns
            - telnyx
            - twilio
            - gupshup
            - firetext
            - infobip-sms
            - burst-sms
            - bulk-sms
            - isend-sms
            - forty-six-elks
            - kannel
            - maqsam
            - termii
            - africas-talking
            - novu-sms
            - sendchamp
            - generic-sms
            - clicksend
            - bandwidth
            - messagebird
            - simpletexting
            - azure-sms
            - ring-central
            - brevo-sms
            - eazy-sms
            - mobishastra
            - afro-message
            - unifonic
            - smsmode
            - imedia
            - sinch
            - isendpro-sms
            - cm-telecom
            - fcm
            - apns
            - expo
            - one-signal
            - pushpad
            - push-webhook
            - pusher-beams
            - appio
            - novu
            - slack
            - discord
            - msteams
            - mattermost
            - ryver
            - zulip
            - grafana-on-call
            - getstream
            - rocket-chat
            - whatsapp-business
            - chat-webhook
            - novu-slack
            - telegram
            - anthropic
            - novu-anthropic
            - anthropic-aws
          example: slack
        integrationIdentifier:
          type: string
          nullable: true
          description: The identifier of the integration to use for this channel endpoint.
          example: slack-prod
        connectionIdentifier:
          type: string
          nullable: true
          description: The identifier of the channel connection used for this endpoint.
          example: slack-connection-abc123
        subscriberId:
          type: string
          nullable: true
          description: The subscriber ID to which the channel endpoint is linked
          example: subscriber-123
        contextKeys:
          description: The context of the channel connection
          example:
            - tenant:org-123
            - region:us-east-1
          type: array
          items:
            type: string
        type:
          type: string
          description: Type of channel endpoint
          enum:
            - slack_channel
            - slack_user
            - webhook
            - phone
            - ms_teams_channel
            - ms_teams_user
            - telegram_chat
          example: slack_channel
        endpoint:
          description: Endpoint data specific to the channel type
          oneOf:
            - $ref: '#/components/schemas/SlackChannelEndpointDto'
            - $ref: '#/components/schemas/SlackUserEndpointDto'
            - $ref: '#/components/schemas/WebhookEndpointDto'
            - $ref: '#/components/schemas/PhoneEndpointDto'
            - $ref: '#/components/schemas/MsTeamsChannelEndpointDto'
            - $ref: '#/components/schemas/MsTeamsUserEndpointDto'
            - $ref: '#/components/schemas/TelegramChatEndpointDto'
        createdAt:
          type: string
          description: >-
            The timestamp indicating when the channel endpoint was created, in
            ISO 8601 format.
        updatedAt:
          type: string
          description: >-
            The timestamp indicating when the channel endpoint was last updated,
            in ISO 8601 format.
      required:
        - identifier
        - channel
        - providerId
        - integrationIdentifier
        - connectionIdentifier
        - subscriberId
        - contextKeys
        - type
        - endpoint
        - createdAt
        - updatedAt
    ErrorDto:
      type: object
      properties:
        statusCode:
          type: number
          description: HTTP status code of the error response.
          example: 404
        timestamp:
          type: string
          description: Timestamp of when the error occurred.
          example: '2024-12-12T13:00:00Z'
        path:
          type: string
          description: The path where the error occurred.
          example: /api/v1/resource
        message:
          description: Value that failed validation
          oneOf:
            - type: string
              nullable: true
            - type: number
            - type: boolean
            - type: object
              nullable: true
            - type: array
              items:
                anyOf:
                  - type: string
                    nullable: true
                  - type: number
                  - type: boolean
                  - type: object
                    additionalProperties: true
          example: 'xx xx xx '
        ctx:
          type: object
          description: Optional context object for additional error details.
          additionalProperties: true
          example:
            workflowId: some_wf_id
            stepId: some_wf_id
        errorId:
          type: string
          description: >-
            Optional unique identifier for the error, useful for tracking using
            Sentry and 
                  New Relic, only available for 500.
          example: abc123
      required:
        - statusCode
        - timestamp
        - path
    ValidationErrorDto:
      type: object
      properties:
        statusCode:
          type: number
          description: HTTP status code of the error response.
          example: 404
        timestamp:
          type: string
          description: Timestamp of when the error occurred.
          example: '2024-12-12T13:00:00Z'
        path:
          type: string
          description: The path where the error occurred.
          example: /api/v1/resource
        message:
          description: Value that failed validation
          oneOf:
            - type: string
              nullable: true
            - type: number
            - type: boolean
            - type: object
              nullable: true
            - type: array
              items:
                anyOf:
                  - type: string
                    nullable: true
                  - type: number
                  - type: boolean
                  - type: object
                    additionalProperties: true
          example: 'xx xx xx '
        ctx:
          type: object
          description: Optional context object for additional error details.
          additionalProperties: true
          example:
            workflowId: some_wf_id
            stepId: some_wf_id
        errorId:
          type: string
          description: >-
            Optional unique identifier for the error, useful for tracking using
            Sentry and 
                  New Relic, only available for 500.
          example: abc123
        errors:
          type: object
          description: A record of validation errors keyed by field name
          additionalProperties:
            $ref: '#/components/schemas/ConstraintValidation'
          example:
            fieldName1:
              messages:
                - Field is required
                - Must be a valid email address
              value: invalidEmail
            fieldName2:
              messages:
                - Must be at least 18 years old
              value: 17
            fieldName3:
              messages:
                - Must be a boolean value
              value: true
            fieldName4:
              messages:
                - Must be a valid object
              value:
                key: value
            fieldName5:
              messages:
                - Field is missing
              value: null
            fieldName6:
              messages:
                - Undefined value
      required:
        - statusCode
        - timestamp
        - path
        - errors
    SlackChannelEndpointDto:
      type: object
      properties:
        channelId:
          type: string
          description: Slack channel ID
          example: C123456789
      required:
        - channelId
    SlackUserEndpointDto:
      type: object
      properties:
        userId:
          type: string
          description: Slack user ID
          example: U123456789
      required:
        - userId
    WebhookEndpointDto:
      type: object
      properties:
        url:
          type: string
          description: Webhook URL
          example: https://example.com/webhook
        channel:
          type: string
          description: Optional channel identifier
      required:
        - url
    PhoneEndpointDto:
      type: object
      properties:
        phoneNumber:
          type: string
          description: Phone number in E.164 format
          example: '+1234567890'
      required:
        - phoneNumber
    MsTeamsChannelEndpointDto:
      type: object
      properties:
        teamId:
          type: string
          description: MS Teams team ID
          example: 19:abc123...@thread.tacv2
        channelId:
          type: string
          description: MS Teams channel ID
          example: 19:def456...@thread.tacv2
      required:
        - teamId
        - channelId
    MsTeamsUserEndpointDto:
      type: object
      properties:
        userId:
          type: string
          description: MS Teams user ID
          example: 29:1234567890abcdef
      required:
        - userId
    TelegramChatEndpointDto:
      type: object
      properties:
        chatId:
          type: string
          description: Telegram chat ID
          example: '123456789'
      required:
        - chatId
    ConstraintValidation:
      type: object
      properties:
        messages:
          type: array
          items:
            type: string
          description: List of validation error messages
          example:
            - Field is required
            - Invalid format
        value:
          description: Value that failed validation
          oneOf:
            - type: string
              nullable: true
            - type: number
            - type: boolean
            - type: object
            - type: array
              items:
                anyOf:
                  - type: string
                    nullable: true
                  - type: number
                  - type: boolean
                  - type: object
                    additionalProperties: true
          example: 'xx xx xx '
      required:
        - messages
  headers:
    Content-Type:
      required: true
      description: The MIME type of the response body.
      schema:
        type: string
      example: application/json
    RateLimit-Limit:
      required: false
      description: >-
        The number of requests that the client is permitted to make per second.
        The actual maximum may differ when burst is enabled.
      schema:
        type: string
      example: '100'
    RateLimit-Remaining:
      required: false
      description: The number of requests remaining until the next window.
      schema:
        type: string
      example: '93'
    RateLimit-Reset:
      required: false
      description: >-
        The remaining seconds until a request of the same cost will be
        refreshed.
      schema:
        type: string
      example: '8'
    RateLimit-Policy:
      required: false
      description: The rate limit policy that was used to evaluate the request.
      schema:
        type: string
      example: >-
        100;w=1;burst=110;comment="token
        bucket";category="trigger";cost="single"
    Idempotency-Key:
      required: false
      description: The idempotency key used to evaluate the request.
      schema:
        type: string
      example: '8'
    Idempotency-Replay:
      required: false
      description: Whether the request was a replay of a previous request.
      schema:
        type: string
      example: 'true'
    Retry-After:
      required: false
      description: >-
        The number of seconds after which the client may retry the request that
        was previously rejected.
      schema:
        type: string
      example: '8'
  securitySchemes:
    secretKey:
      type: apiKey
      name: Authorization
      in: header
      description: >-
        API key authentication. Allowed headers-- "Authorization: ApiKey
        <novu_secret_key>".
      x-speakeasy-example: YOUR_SECRET_KEY_HERE

````